;-----   Application avec un PIC : Essais sur l ' EEPROM ------

; Titre : essais sur l ' EEPROM
; Date : 10 octobre 2001
; Auteur : P.M
; PIC utilis : PIC 16 F 84
; Dans cet exercice on crit la valeur 55  l' adresse 0 de la mmoire eeprom,
; puis on vient relire cette valeur et on la stocke dans le registre W

;------------   Directive d' assemblage pour PLAB   ---------------

	list	p=16f84A
	#include p16f84A.inc
	__config H'3FF9'   

;------------   Dfinition des constantes   ---------------

W      			     EQU     0x00        ; variable W = 0 
F	 		     EQU     0x01        ; variable F = 1
					
;------------   Dfinition des registres temporaires   ---------------

adresse	     EQU	0x20	  
donne	     EQU	0x21	  

;***************   Numero de version  ***************

	org h'2110'
	de "Essais sur l ' Eprom ver 1.0 10/10/01 "

;***************   Programme principal  ***************

	ORG 0

	clrf adresse    	; registre adresse = 0
	MOVLW 0x55              ; on met 55 dans le registre W
        MOVWF donne            ; on met 55 dans le registre donne

;********************** Mmorisation en EPROM ***************************************


 	  bsf STATUS,5		; on met  1 le 5eme bit du registre status pour accder
    				;  la 2eme page mmoire ( pour EECON1 et EECON2 )
          MOVLW 0x04            ; on met 04 dans le registre W
          MOVWF EECON1          ; on met 04 dans le registre EECON1
	  
	  bcf STATUS,5		; on remet  0 le 5eme bit du registre status  

          movf adresse,W	; on met le registre adresse dans W
	  MOVWF EEADR           ; on met W sur EEADR ( adresse EPROM )
          movf donne,W		; on met le contenu du registre donne (55)dans W
	  MOVWF  EEDATA         ; on met W sur EEDATA ( donne EPROM )

   	  bsf STATUS,5		; on met  1 le 5eme bit du registre status pour accder 
    				;  la 2eme page mmoire ( pour EECON1 et EECON2 )
	  
	  movlw 0x55		; passage obligatoire pour ecrire en EPROM
	  movwf EECON2		;...
	  movlw 0xAA		;...
	  movwf EECON2		;...
	  bsf EECON1,1		;...

	  bcf STATUS,5		; on remet  0 le 5eme bit du registre status 
 
	  
;********************** Lecture EPROM  ***************************************
 

	 MOVF  adresse, W      ; on met le registre EEPROM dans W
         MOVWF  EEADR          ; on met W sur EEADR ( adresse EPROM )
	 bsf STATUS,5	       ; on met  1 le 5eme bit du registre status pour accder
    			       ;  la 2eme page mmoire ( EECON1 )

         MOVLW 0x01            ; on met 01 dans le registre W
         MOVWF EECON1          ; on met 01 dans le registre EECON1
 	 bcf STATUS,5	       ; on remet  0 le 5eme bit du registre status 
	
	 
	 MOVF  EEDATA, W       ; on met la donne EPROM dans W

;******************************************************************************	
	
	END
 






